// Thanks KermMartian for the sin/cos/tan routines
extern  float  __sinf(float); 
extern  float  __tanf(float); 
#define __cosf(x) __sinf((PIOVERTWO)+(x)) 

#define PIOVERTWO 1.570796327f 
#define PI 3.141592654f 
#define PISQUARED 9.869604401f 
#define EXTRA_PRECISION 

float __sinf(float x) 
{ 
   while (x > PI) x-=(2.f*PI); 
   while (x < -PI) x+=(2.f*PI); 
    const float B = 4/PI; 
    const float C = -4/(PISQUARED); 

    float y = B * x + C * x * fabsf(x); 

    #ifdef EXTRA_PRECISION 
    //  const float Q = 0.7775; 
        const float P = 0.224008178776; 

        y = P * (y * fabsf(y) - y) + y;   // Q * y + P * y * abs(y) 
    #endif 
    
   return y; 
} 

float __tanf(float x) { 
   float y = __sinf(x); 
   return y/((PIOVERTWO)-y); 
} 

// Found this somewhere on the internets
float __sqrtf(float x)
{
   unsigned int i = *(unsigned int*) &x; 
   // adjust bias
   i  += 127 << 23;
   // approximation of square root
   i >>= 1; 
   return *(float*) &i;
} 

float dist(float x1, float y1, float x2, float y2)
{
        return __sqrtf((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
}
